'--------------------------------------------------------------
' ESM32 Interface 2, ASCII-Kommandos
' ATMEGA32,  16 MHz, 19200 Baud
'--------------------------------------------------------------

$regfile = "m32def.dat"
$baud = 19200
$crystal = 16000000
$hwstack = 32
$swstack = 64
$framesize = 64


Dim Command As Byte
Dim N As Byte
Dim L As Byte
Dim H As Byte
Dim K As Byte
Dim D As Byte
Dim Dd As Word
Dim Kommando As String * 10
Dim Kommando1 As String * 6
Dim Kommando2 As String * 6
Dim Zeichen As String * 1
Dim Daten As Word




Open "com1:" For Binary As #1

Config Portd = &B00110000
Portd.2 = 1
Portd.3 = 1
Portd.6 = 1
Portd.7 = 1



Config Adc = Single , Prescaler = Auto , Reference = Off    ' Pre 8...32
Start Adc

Config Timer1 = Pwm , Prescale = 8 , Pwm = 10 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down
Start Timer1


'Echo Off

Do
  Input #1 , Kommando
  K = 1
  Kommando1 = ""
  Kommando2 = ""
  L = Len(kommando)
  For N = 1 To L
    Zeichen = Mid(kommando , N , 1)
    If K = 1 Then
      If Zeichen <> " " Then
        Kommando1 = Kommando1 + Zeichen
      End If
      If Zeichen = " " Then K = 2
    End If
    If K = 2 Then
      If Zeichen <> " " Then
        Kommando2 = Kommando2 + Zeichen
      End If
      If Zeichen = " " Then K = 2
    End If
  Next N

  'Print #1 , Kommando1
  'Print #1 , Kommando2

  If Kommando1 = "?" Then
     Print #1 , "OK"
  End If

  If Kommando1 = "PORTA" Then
     D = Val(kommando2)
     Porta = D
  End If

  If Kommando1 = "PORTB" Then
     D = Val(kommando2)
     Portb = D
  End If

  If Kommando1 = "PORTC" Then
     D = Val(kommando2)
     Portc = D
  End If

  If Kommando1 = "PORTD" Then
     D = Val(kommando2)
     Portd = D
  End If

  If Kommando1 = "PINA" Then
     D = Pina
     Print #1 , D
  End If

  If Kommando1 = "PINB" Then
     D = Pinb
     Print #1 , D
  End If

  If Kommando1 = "PINC" Then
     D = Pinc
     Print #1 , D
  End If

  If Kommando1 = "PIND" Then
     D = Pind
     Print #1 , D
  End If

 If Kommando1 = "DDRA" Then
     D = Val(kommando2)
     Ddra = D
  End If

  If Kommando1 = "DDRB" Then
     D = Val(kommando2)
     Ddrb = D
  End If

  If Kommando1 = "DDRC" Then
     D = Val(kommando2)
     Ddrc = D
  End If

  If Kommando1 = "DDRD" Then
     D = Val(kommando2)
     Ddrd = D
  End If


  If Kommando1 = "ADC0" Then
     Dd = Getadc(0)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC1" Then
     Dd = Getadc(1)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC2" Then
     Dd = Getadc(2)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC3" Then
     Dd = Getadc(3)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC4" Then
     Dd = Getadc(4)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC5" Then
     Dd = Getadc(5)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC6" Then
     Dd = Getadc(6)
     Print #1 , Dd
  End If

  If Kommando1 = "ADC7" Then
     Dd = Getadc(7)
     Print #1 , Dd
  End If

  If Kommando1 = "PWM1A" Then
     Dd = Val(kommando2)
     Pwm1a = Dd
  End If

  If Kommando1 = "PWM1B" Then
     Dd = Val(kommando2)
     Pwm1b = Dd
  End If

Loop


End